c MKPE3
c Vypocet tlaku v potrubni siti. Laminarni/turbulentni proudeni.
c Reseni soustavy nelinearnich rovnic metodou substituci.
c
c Spolecne parametry pro vsechny elementy: rho-hustota, ami-viskozita
c
c Vyznamy poli:
c 2 - noe  [indexy uzlu elementu, matice ma dva sloupce pro 2 uzly elementu]
c 3 - pe   [Re,Q-objemovy prutok,r-polomer trubky,k-stredni drsnost]
c 4 - xy   [x,y]
c 5 - ipu  [indexy parametru uzlu, zaporna hodnota znamena predepsany tlak]
c 6 - rpu1 [parametry uzlu-tlaky]
c 7 - rpu  [zadavane hodnoty tlaku a prutoku]
c 8 - rpu2 [parametry uzlu-tlaky]
c 9 - rpu1 & rpu2 [soucasne zobrazeni dvou iteraci]
c 10       [textove pole hlavicek matic]
c
c Pozn. Pole 6 a 8 se vyuzivaji jako houpacka [stridave ukladani vysledku
c       v jednotlivych iteracich]. Pred kazdou iteraci je ve vektoru 7 ulo-
c       zeno zadani (zadavane tlaky nebo prutoky) a ve vektoru 6 nebo 8
c       je vysledek predchozi iterace (tlaky ve vsech uzlech), ktere potre-
c       bujeme pro odhad Re.
c
      common /cradle/ip1,ip2,rho,ami
      character inkey*4
      external lokal,sext
      data ifl/1/
      rho=1000.
      ami=1.
      call scomin(-1)
      call sintro('xmkpe3.for')
      call mtobir('XMKPE3.MAT',iend)
      call mtools(0,sext)
111   call sclear
      call minpr(0,' Density [kg/m^3]=',18,16,2,rho)
      call minpr(0,' Viscosity [Pa.s]=',18,17,2,ami)
1     call mefrin(2,5)
      ip1=7+ifl
      ip2=7-ifl
      ifl=-ifl
c
c presun vektoru zadavanych tlaku do vektoru IP1
c
      call move(ip1,7)
      call mefron(2,5,ip1,50,2,lokal,0)
      call graf(kbd)
c F1-zoom F2-zoomout F3-tools F4-list F5-visc [Esc]-Exit
      if(kbd.eq.61)then
         call mtools(0,sext)
      elseif(kbd.eq.62)then
         call sintro('xmkpe3.for')
      elseif(kbd.eq.63)then
         goto111
      elseif(kbd.eq.27)then
         call scwrit(16,10,28,23,' Do You want to quit? (Y/N) ')
         call skbdr(inkey)
         if(inkey.eq.'Y   '.or.inkey.eq.'y   ') goto999
      endif
      goto 1
999   call sclear
      end

      subroutine lokal(ie,nl,nn,a,b)
c
c Lokalni matice prutoku a(2,2) a vektor prutoku v uzlech b(2)
c
      dimension a(nl,nl),b(nl),x(2),y(2),pres(2),ibound(2)
      call gett3(ie,fi,x,y,pres,ibound,Re)
      a(1,1)=fi
      a(2,2)=fi
      a(1,2)=-fi
      a(2,1)=-fi
      b(1)=0.
      b(2)=0.
      end

      subroutine gett3(ie,fi,x,y,pres,ibound,re)
      common z(10000) /cradle/ip1,ip2,rho,ami
      dimension iz(10000),x(2),y(2),pres(2),ibound(2)
      real karm,lambda
      equivalence (iz,z)
c
c stanoveni polomeru trubky elementu IE
c
      call mlocr(3,ie,1,loc,it,npe,idif)
      r=z(loc+2*idif)
      drsnost=z(loc+3*idif)
      drs=drsnost/(2000*r)
      call mlocr(2,ie,1,locu,it,nue,idifu)
      iu1=iabs(iz(locu))
      iu2=iabs(iz(locu+idifu))
c
c zjisteni delky elementu IE ze souradnic x,y uzlu 1,2
c
      call mlocr(4,iu1,1,lx1,idum,nxy,it1)
      call mlocr(4,iu2,1,lx2,idum,nxy,it2)
      x(1)=z(lx1)
      x(2)=z(lx2)
      y(1)=z(lx1+it1)
      y(2)=z(lx2+it2)
      h=sqrt((x(1)-x(2))**2+(y(1)-y(2))**2)
c
c indexy parametru uzlu ibound(i) elementu IE
c a hodnoty tlaku pres(i)
c
      call mloc(5,iu1,1,lu1,it)
      call mloc(5,iu2,1,lu2,it)
      ibound(1)=iz(lu1)
      ibound(2)=iz(lu2)
      call mloc(ip2,iabs(iz(lu1)),1,lr1,it)
      call mloc(ip2,iabs(iz(lu2)),1,lr2,it)
      pres(1)=z(lr1)
      pres(2)=z(lr2)
      dp=abs(z(lr1)-z(lr2))
      Re=r**3*dp*rho/(4*ami**2*h)
      if(Re.lt.2300.)then
c
c Hagen Poisseuile Lamba=64/Re
c
          fi=3.141*r**4/(8*ami*h)
      else
c
c Charles
c
          karm=(2*r/ami)*(sqrt(4*r*rho*dp/h))
          apom=((-2)*alog10(0.27*drs+(2.55+30*drs)/karm))**24
          bpom=(12800/karm)**12
          lambda=((64/karm)**24+1/(apom+bpom))**(1/12)
          reynold=karm/(sqrt(lambda))
          fi=(3.141*(2*r)**4)/(2*h*ami*lambda*reynold)
      endif
c
c Ulozeni vypocteneho prutoku Q jako druheho parametru elementu
c
      z(loc+idif)=fi*dp
c
c Ulozeni vypocteneho Re jako prvniho parametru elementu
c
      z(loc)=2*z(loc+idif)*rho/(3.141*r*ami)
      end

      subroutine graf(kbd)
c
c zobrazeni grafu potrubni site, vypis tlaku a hodnot Re
c
      dimension x(2),y(2),ibound(2),p(2)
      character *13 label
      call mpara(2,kod,mat,ne,n,loc,len)
60    xmi=1e10
      xma=-1e10
      ymi=1e10
      yma=-1e10
      do1ie=1,ne
      call gett3(ie,fi,x,y,p,ibound,re)
      do1i=1,2
         xmi=amin1(xmi,x(i))
         xma=amax1(xma,x(i))
         ymi=amin1(ymi,y(i))
         yma=amax1(yma,y(i))
1     continue
50    dx=(xma-xmi)*.1
      dy=(yma-ymi)*.1
      call gmfin
      call gmfstf(1,0.,1.,0.1,1.,xmi-dx,xma+dx,ymi-dy,yma+dy)
c F1-zoom F2-zoomout F3-tools F4-list F5-visc [Esc]-Exit
      call scwrit(24,0,79,15,'[F1]-zoomin [F2]-zoomout [F3]-tools [F4]-l
     /ist [F5]-rho,mi [Enter]-comput. [Esc]')
      call gmfsw(1)
      do2ie=1,ne
         call gett3(ie,fi,x,y,p,ibound,re)
         call gmfpl(2,x,y,1)
         do22i=1,2
            if(ibound(i).le.0)then
               call gmfmrk(x(i),y(i),15)
            else
               call gmfmrk(x(i),y(i),12)
            endif
            write(label,30)p(i)
30          format(e10.3)
            call gmftext(x(i),y(i),2,10,label)
22       continue
         write(label,40)re
40       format('Re=',e10.3)
         call gmftext((x(1)+x(2))*.5,(y(1)+y(2))*.5,3,13,label)
2     continue
      call skbdr(kbd)
      if(kbd.eq.59)then
          call gmflcw(xmi,xma,ymi,yma,xmi,xma,ymi,yma,kbd)
          goto 50
      elseif(kbd.eq.60)then
          goto 60
      endif
      call gmfmon
      end

      subroutine sext(i,itx,j1,j2,ict)
c vysvetlivky jsou v poli cislo 10
      common m(20000)
      integer itx(*)
      equivalence (lab,m(82)),(nlab,m(89))
      if(ict.eq.54.or.ict.eq.53)then
          call mpanel(1,2,7,7,m(lab+(i-1)*nlab),1,nlab,nlab,m)
          call mpanel(17,2,23,7,
     /    '                            '//
     /    '  Please prepare new data:  '//
     /    '  Select matrix and [Enter] '//
     /    '  Select trace mode by [F1] '//
     /    '  Computation - [$3F9 $]    '//
     /    '                            ',6,7,7,m)
      endif
c rozsireni editoru MED
      call medcex(i,itx,j1,j2,ict)
      end

