c MKPE7 @Zitny 4/92
c Rotacne symetricka skorepina zatizena vnitrnim pretlakem
c
c Pouzit dvouuzlovy prvek, popisovany v (opraveny 2 chyby v mat.tuh.):
c Schneider P., Vykutil J.: Stavba chemickych zarizeni II, Brno 1990
c
c Vyznamy poli:
c 2 - noe  [indexy uzlu elementu]
c 3 - rx   [r,x]
c 4 - ipu  [indexy parametru uzlu-matice se 3-mi sloupci u,w,beta]
c 5 - rpu  [parametry uzlu- u,w,beta]
c 6 - pe   [parametry elementu-p/tlak/,t/tloustka/,
c                              N1,N2,M1,M2,Q - vnitrni sily]
c 7 - help [textove pole]
c
      common /prop/E,rmi /scom/iss(50)
      external lokal,sext
      character inkey*4
      equivalence (ict,iss(3)),(kbdr,iss(13))
      E=2.1e11
      rmi=0.3
      call scomin(-1)
      call sintro('xmkpe7.for')
      call mtobir('xmkpe7.mat',iend)
2     call sclear
      call minpr(0,' Young modulus E   [Pa]=',24,15,2,E)
      call minpr(0,' Poisson''s constant [-]=',24,16,2,rmi)
1     call mtools(0,sext)
      if(kbdr.eq.67)then
         call mefrin(2,4)
c Vypocet posunuti u,w,beta
         call mefron(2,4,5,50,6,lokal,0)
c Vypocet zobecnenych sil v elementech
         ict=1
         call mefron(2,4,5,50,6,lokal,0)
         ict=0
      endif
      call grid(kbd)
      if(kbd.eq.61)then
        goto 2
      elseif(kbd.eq.27)then
        call scwrit(16,10,28,23,' Do You want to quit? [Y/N] ')
        call skbdr(inkey)
        if(inkey.eq.'Y   '.or.inkey.eq.'y   ')goto999
      endif
      goto 1
999   call sclear
      end

      subroutine lokal(ie,nl,nn,al,bl)
c
c ict=0 - lokalni matice tuhosti a vektor zatizeni tlakem
c ict=1 - vypocet vnitrnich sil v tezisti elementu
c
      dimension al(nl,nl),bl(nl),r(2),x(2),u(2),w(2),beta(2),node(2),
     /          forces(5)
      common /prop/E,rmi /scom/iss(50)
      equivalence (ict,iss(3))
      call get(ie,x,r,u,w,beta,p,t,node,forces)
      d11=e*t/(1-rmi**2)
      d22=d11
      d12=d11*rmi
      d33=d11*t**2/12
      d44=d33
      d34=d33*rmi
      d55=5*e*t/(12*(1+rmi))
      rl=sqrt((r(1)-r(2))**2+(x(1)-x(2))**2)
      c=(x(2)-x(1))/rl
      s=(r(2)-r(1))/rl
      rc=(r(1)+r(2))*.5
      if(ict.eq.0)then
c frontalni metoda
        s2=s**2
        c2=c**2
        rc4=4*rc**2
        al(1,1)=rc*(d11*c2+d55*s2)/rl
        al(4,4)=al(1,1)
        al(1,4)=-al(1,1)
        al(1,2)=c*rc*(s*(d11-d55)-rl*d12/(2*rc))/rl
        al(2,4)=-al(1,2)
        al(4,5)=c*rc*(s*(d11-d55)+rl*d12/(2*rc))/rl
        al(1,5)=-al(4,5)
        al(3,4)=rc*s/2*d55
        al(1,6)=-al(3,4)
        al(1,3)=-al(3,4)
        al(4,6)=al(3,4)
        al(2,3)=rc*c/2*d55
        al(5,6)=-al(2,3)
        al(3,5)=-al(2,3)
        al(2,6)=al(2,3)
        h1=s*d34/rc
        h2=d33/rl+d55*rl/4+s2*rl*d44/rc4
        al(3,3)=rc*(h2-h1)
        al(6,6)=rc*(h2+h1)
        w1=(s2*d11+c2*d55)/rl
        w2=rl*d22/rc4
        al(2,2)=rc*(w1+w2-s*d12/rc)
        al(5,5)=rc*(w1+w2+s*d12/rc)
        al(2,5)=rl*d22/(4*rc)-rc*w1
        al(3,6)=rc*(-d33/rl+s2*rl*d44/rc4+d55*rl/4)
        do1i=2,6
        do1j=1,i-1
1       al(i,j)=al(j,i)
        pl8=p*rl/8
        bl(1)=-pl8*s*(3*r(1)+r(2))
        bl(2)= pl8*c*(3*r(1)+r(2))
        bl(3)=0
        bl(4)=-pl8*s*(r(1)+3*r(2))
        bl(5)= pl8*c*(r(1)+3*r(2))
        bl(6)=0
      else
c vnitrni sily: u-posun x    w-posun r
        wm=u(2)-u(1)
        um=w(2)-w(1)
        up=w(1)+w(1)
        bm=beta(2)-beta(1)
        bp=beta(1)+beta(2)
        rn1=c*d11/rl*wm+s*d11/rl*um+d12*up/(2*rc)
        rn2=c*d12/rl*wm+s*d12/rl*um+d22*up/(2*rc)
        rm1=d33*bm/rl+s*d34*bp/(2*rc)
        rm2=d34/rl*bm+s*d33*bp/(2*rc)
        q=s*d55*wm/rl+c*d55*um/rl+d55*bp/2
        call put(ie,rn1,rn2,rm1,rm2,q)
      endif
      end

      subroutine put(ie,rn1,rn2,rm1,rm2,q)
c
c ulozeni vnitrnich sil do matice 6-pe sloupcem 3 pocinaje
c
      common ma(20000)
      dimension ra(20000)
      equivalence (ma,ra)
      call mlocr(6,ie,3,loc,it,np,id)
      ra(loc)     =rn1
      ra(loc+id)  =rn2
      ra(loc+2*id)=rm1
      ra(loc+3*id)=rm2
      ra(loc+4*id)=q
      end

      subroutine get(ie,x,r,u,w,beta,p,t,node,forces)
c
c data transfer x(2),r(2),u(2),w(2),beta(2),press,thickness,node(2),forces(5)
c 2-nue 3-xr 4-ipu 5-rp 6-pe
c
      common z(10000)
      dimension x(2),r(2),u(2),w(2),beta(2),node(2),forces(5),iz(10000)
      equivalence (z,iz)
      call mlocr(2,ie,1,loc,it,np,idif)
      do 1 i=1,2
         indu=iabs(iz(loc+(i-1)*idif))
         call mlocr(5,indu,1,locp,it,npu,idpu)
         node(i)=indu
         u(i)=z(locp)
         w(i)=z(locp+idpu)
         beta(i)=z(locp+2*idpu)
         call mlocr(3,indu,1,locp,it,npu,idpu)
         r(i)=z(locp)
1        x(i)=z(locp+idpu)
      call mlocr(6,ie,1,locp,it,np,idpu)
      p=z(locp)
      locp=locp+idpu
      t=z(locp)
      do 2 i=1,5
      locp=locp+idpu
2     forces(i)=z(locp)
      end

      subroutine sext(i,itx,j1,j2,ict)
c vysvetlivky jsou v poli cislo 7
      common m(20000) /scom/iss(50)
      character *16 ifile,jfile
      equivalence (lab,m(55)),(nlab,m(62)),(iout,iss(12))
      data ifile/'*.mod'/
      if(ict.eq.54.or.ict.eq.53)then
          call mpanel(1,2,7,7,m(lab+(i-1)*nlab),1,nlab,nlab,m)
          call mpanel(16,2,23,7,
     /    '                                '//
     /    '  Please prepare new data:      '//
     /    '$5Created by COSMOS$[$3F10  $]  '//
     /    '  or manually:                  '//
     /    '$5Select matrix and$[$3Enter$]  '//
     /    '  Start:                        '//
     /    '$5Computation$- by $[$3F9 $  ]  ',7,8,8,m)
      elseif(ict.eq.55)then
          call minpf(1,' File MODINPUT:',15,14,2,ifile,16,10,40,24,
     /               jfile,16,ires)
          if(ires.gt.0)then
             open(30,file=jfile)
             call modinp(30, 2,2, 3,2, 4,3, 5,  6)
C                            iue  ixy  ipu  rp  ipe
             iout=3
             close(30)
          endif
      else
          call medcex(i,itx,j1,j2,ict)
      endif
      end

      subroutine grid(kbd)
c
c graphics
c
      dimension x(2),r(2),u(2),w(2),beta(2),node(2),forces(5)
      character *9 label, lfor(6)*4
      data lfor/'node','Nmer','Ncir','Mmer','Mcir','Q   '/
      call mpara(2,kod,mat,ne,n,loc,len)
      iforce=0
60    xmi=1e10
      xma=-1e10
      rmi=1e10
      rma=-1e10
      uma=1e-15
      wma=1e-15
      do1ie=1,ne
      call get(ie,x,r,u,w,beta,p,t,node,forces)
      do1i=1,2
         xmi=amin1(xmi,x(i))
         xma=amax1(xma,x(i))
         rmi=amin1(rmi,r(i))
         rma=amax1(rma,r(i))
         uma=amax1(uma,abs(u(i)))
         wma=amax1(wma,abs(w(i)))
1     continue
50    dx=amax1(uma,(xma-xmi)*.1)
      dr=amax1(wma,(rma-rmi)*.1)
      scaleu=dx/uma
      scalew=dr/wma
      call gmfin
      call gmfst(1,0.,1.,0.1,1.,rmi-dr,rma+dr,xmi-dx,xma+dx)
      call gmfsyl('R [m]',5,'X [m]',5)
51    call gmfaxl(1,3,11)
      call scwrit(24,0,77,15,' [F1]-zooming [F2]-zoomout [F3]-E,mi [F4]-
     /label:'//lfor(iforce+1)//' [Enter]-tools [Esc]-quit')
      call gmfsw(1)
      if(iforce.gt.0)then
         fmax=1e-15
         tmax=1e-10
         imax=1
         do40ie=1,ne
         call get(ie,x,r,u,w,beta,p,t,node,forces)
         aforce=abs(forces(iforce))
         tmax=amax1(tmax,t)
         if(aforce.gt.fmax)then
            fmax=aforce
            imax=ie
         endif
40       continue
      endif
      do22ie=1,ne
         call get(ie,x,r,u,w,beta,p,t,node,forces)
         if(iforce.eq.0)then
            call gmfpl(2,r,x,2+mod(ie,2))
            do2i=2,1,-1
            call gmfmrk(r(i),x(i),20)
            write(label,30)node(i)
30          format(i2)
            call gmftext(r(i),x(i),1,2,label)
            x(i)=x(i)+u(i)*scaleu
            r(i)=r(i)+w(i)*scalew
            call gmfmrk(r(i),x(i),27)
2           continue
            call gmfpl(2,r,x,4)
         else
            forc=forces(iforce)/fmax*.15
            call gmfort(r,x,forc,forc,t*.007/tmax,1,4,12,rc,xc)
            if(ie.eq.imax)then
               call gmfmrk(rc,xc,10+iforce)
               write(label,31)forces(iforce)
31             format(e9.2)
               call gmftext(rc,xc,1,9,label)
            endif
         endif
22    continue
      call skbdr(kbd)
      if(kbd.eq.59)then
          call gmflcw(rmi,rma,xmi,xma,rmi,rma,xmi,xma,kbd)
          goto 50
      elseif(kbd.eq.60)then
          goto 60
      elseif(kbd.eq.62)then
          iforce=mod(iforce+1,6)
          goto 51
      endif
      call gmfmon
      end
